/********************************** (C) COPYRIGHT *******************************
 * File Name          : main.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2024/06/05
 * Description        : Main program body.
 *********************************************************************************
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * Attention: This software (modified or not) and binary are used for
 * microcontroller manufactured by Nanjing Qinheng Microelectronics.
 *******************************************************************************/

/*
 *@Note
 *Systick interrupt:
 *USART1_Tx(PB10).
 *
 *
 */

#include "debug.h"

/* Global typedef */

/* Global define */

/* Global Variable */
void SysTick_Handler(void) __attribute__((interrupt("WCH-Interrupt-fast")));

static volatile uint32_t runMilis = 0;

void SYSTICK_Init_Config(u64 ticks)
{
    SysTick->SR = 0;
    SysTick->CNT = 0;
    SysTick->CMP = ticks;
    SysTick->CTLR =0xF;

    NVIC_SetPriority(SysTicK_IRQn, 15);
    NVIC_EnableIRQ(SysTicK_IRQn);
}

void SysTick_Handler(void)
{
//    printf("welcome to WCH\r\n");
    runMilis++;
    SysTick->SR = 0;
//    printf("Counter:%d\r\n",runMilis);
}

//-------------------------------------------------------------------------------------//
// Get System tick counter
//-------------------------------------------------------------------------------------//
uint32_t get_time_tick(void)
{
    return runMilis;
}

//--------------------------------------------------------------------------//
// Delay function
//--------------------------------------------------------------------------//
void DelayMS( uint32_t nMS )
{
    volatile uint32_t now = get_time_tick();
//    printf("now:%d\r\n", now);
//    printf("runMilis:%d\r\n", get_time_tick());
    while( (get_time_tick() - now) < nMS );
}

/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main(void)
{
    SystemCoreClockUpdate();
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);
    USART_Printf_Init(115200);
    printf("SystemClk:%d\r\n", SystemCoreClock);
    printf( "ChipID:%08x\r\n", DBGMCU_GetCHIPID() );

    SYSTICK_Init_Config((SystemCoreClock/1000)-1);
    while(1)
    {
        DelayMS(500);
        printf("test\r\n");
    }
}
